/*** Aufgabe_09_3.cpp ***/
#include <fstream>
#include <iostream>

#include "Aufgabe_09_3.h"

using namespace std;

int main() {
    int array1[] = {6, 8, 2, 7 ,9, 1, 3};
    unsigned int length = sizeof(array1) / sizeof(int);

    BinTree<int> baum1;

    for (unsigned int i = 0; i < length; ++i) {
        baum1.insert(array1[i]);
    }
    baum1.printToConsole();

    /* Testen Sie hier die Vorgaenger-Funktion */
    for (unsigned int i = 0; i < length; ++i) {
        cout << "Vorgaenger von " << i*2 << " = ";
        baum1.predValue(i*2);
        cout << endl;
    }

    /* Jetzt fuer den ersten Baum die Ausgabe von countNodes() testen */
    cout << "Anzahl der Knoten von Baum 1: " << baum1.countNodes() << endl;

	cout << endl << "--------------" << endl << endl;

	// *** Fuer Aufgabe 3: ***
	// *** Hier baum2 als Kopie von baum1 mit Hilfe des Kopierkonstruktors erzeugen. ***
	cout << "Kopierkonstruktor: baum2(baum1)" << endl;
	BinTree<int> baum2(baum1);
	baum2.printToConsole();
	cout << endl << "----------------------------" << endl << endl;


	// *** Hier baum3 als Kopie von baum1 mit Hilfe des Zuweisungsoperators erzeugen. ***
	cout << "Zuweisungsoperator: baum3 = baum1" << endl;
	BinTree<int> baum3;
	baum3 = baum1;
	baum3.printToConsole();
	cout << endl << "----------------------------" << endl << endl;

    return 0;
}
/*
                                 6
                 2                               8
         1               3               7               9
Vorgaenger von 0 = n/a
Vorgaenger von 2 = 1
Vorgaenger von 4 = n/a
Vorgaenger von 6 = 3
Vorgaenger von 8 = 7
Vorgaenger von 10 = n/a
Vorgaenger von 12 = n/a
Anzahl der Knoten von Baum 1: 7

--------------

Kopierkonstruktor: baum2(baum1)

Process returned -1073741819 (0xC0000005)   execution time : 1.780 s
*/
/********* Ende *********/
